#if __STDC__ || defined(__cplusplus)
#define P_(s) s
#else
#define P_(s) ()
#endif

/* coup.c */
extern void coup P_((void));
/* death.c */
extern void death P_((void));
extern void basepromo P_((void));
/* detonate.c */
extern void detothers P_((void));
/* enter.c */
extern void enter P_((int tno, char *disp, int pno, int s_type));
extern void openmem P_((void));
extern void auto_peace P_((void));
/* findslot.c */
extern int findslot P_((int overload));
extern int grabslot P_((int overload));
extern void mapWaitCount P_((unsigned int count));
/* getentry.c */
extern void getEntry P_((int *team, int *stype));
extern int tournamentMask P_((int team));
extern int deadTeam P_((int owner));
/* getname.c */
extern void getname P_((void));
extern int get_position_from_file P_((char *file, struct statentry *player));
extern int get_position P_((struct statentry *player));
extern void handleLogin P_((void));
extern void savestats P_((void));
/* getship.c */
extern void getship P_((struct ship *shipp, int s_type));
/* input.c */
extern void setflag P_((void));
extern void input P_((void));
extern int reconnect P_((void));
/* interface.c */
extern void set_speed P_((int speed));
extern void set_course P_((int dir));
extern void shield_up P_((void));
extern void shield_down P_((void));
extern void shield_tog P_((void));
extern void bomb_planet P_((void));
extern void beam_up P_((void));
extern void beam_down P_((void));
extern void repair P_((void));
extern void repair_off P_((void));
extern void repeat_message P_((void));
extern void cloak P_((void));
extern void cloak_on P_((void));
extern void cloak_off P_((void));
extern void lock_planet P_((int planet));
extern void lock_player P_((int player));
extern void declare_war P_((int mask));
extern void sendwarn P_((char *string, int atwar, int team));
extern void do_refit P_((int type));
extern int numShips P_((int owner));
extern int numPlanets P_((int owner));
extern void tractor_player P_((int player));
extern void pressor_player P_((int player));
/* main.c */
extern void main P_((int argc, char **argv));
extern void exitGame P_((int gb));
extern void printUsage P_((char *prog));
extern void sendMotd P_((void));
extern void sendConfigMsg P_((void));
extern void reaper P_((int sig));
extern void printStats P_((void));
extern int checkspecial P_((char *file, char *login, char *host));
extern int checkslots P_((char *login, char *host));
extern int samenet P_((char *host1, char *host2));
extern void r2dot P_((char *h, char *buf));
extern void doMotdPics P_((void));
/* mine.c */
/* orbit.c */
extern void orbit P_((void));
extern void dock P_((int base_id));
/* parsexbm.c */
extern int ParseXbmFile P_((FILE *stream, int *widthP, int *heightP, char **dataP));
/* plasma.c */
extern void nplasmatorp P_((int course, int type));
/* phaser.c */
extern void phaser P_((int course));
/* redraw.c */
extern void intrupt P_((void));
extern void auto_features P_((void));
extern unsigned char newcourse P_((int x, int y));
extern void rsa_check P_((void));
/* reserved.c */
extern void makeReservedPacket P_((struct reserved_spacket *packet));
extern void encryptReservedPacket P_((struct reserved_spacket *spacket, struct reserved_cpacket *cpacket, char *server, int pno));
extern void USCencryptReservedPacket P_((struct reserved_spacket *spacket, struct reserved_cpacket *cpacket, char *server, int pno));
/* ping.c */
extern void pingResponse P_((struct ping_cpacket *packet));
extern void sendClientPing P_((void));
extern void calc_loss P_((int i, struct ping_cpacket *packet));
extern void update_lag_stats P_((void));
extern void update_loss_stats P_((void));
extern int msetime P_((void));
extern int uchar_diff P_((int x, int y));
/* socket.c */
extern int connectToClient P_((char *machine, int port));
extern void checkSocket P_((void));
extern void initClientData P_((void));
extern int isClientDead P_((void));
extern void updateClient P_((void));
extern void updateStatus P_((void));
extern void updateSelf P_((void));
extern void updateSelfShort P_((void));
extern void updatePlayerStats P_((void));
extern void updateShips P_((int check_myloc));
extern void updateTorps P_((void));
extern void updatePlasmas P_((void));
extern void updatePhasers P_((void));
extern void updatePlanets P_((void));
extern void updateMessages P_((void));
extern void sendQueuePacket P_((int pos));
extern void sendClientPacket P_((struct player_spacket *packet));
extern void flushSockBuf P_((void));
extern void socketPause P_((void));
extern int readFromClient P_((void));
extern int doRead P_((int asock));
extern void handleTorpReq P_((struct torp_cpacket *packet));
extern void handlePhasReq P_((struct phaser_cpacket *packet));
extern void handleSpeedReq P_((struct speed_cpacket *packet));
extern void handleDirReq P_((struct dir_cpacket *packet));
extern void handleShieldReq P_((struct shield_cpacket *packet));
extern void handleRepairReq P_((struct repair_cpacket *packet));
extern void handleOrbitReq P_((struct orbit_cpacket *packet));
extern void handlePractrReq P_((struct practr_cpacket *packet));
extern void handleBombReq P_((struct bomb_cpacket *packet));
extern void handleBeamReq P_((struct beam_cpacket *packet));
extern void handleCloakReq P_((struct cloak_cpacket *packet));
extern void handleDetTReq P_((struct det_torps_cpacket *packet));
extern void handleCopilotReq P_((struct copilot_cpacket *packet));
extern void handleOutfit P_((struct outfit_cpacket *packet));
extern void sendPickokPacket P_((int state));
extern void handleLoginReq P_((struct login_cpacket *packet));
extern void sendClientLogin P_((struct stats *stats));
extern void handlePlasmaReq P_((struct plasma_cpacket *packet));
extern void handleWarReq P_((struct war_cpacket *packet));
extern void handlePlanlockReq P_((struct planlock_cpacket *packet));
extern void handlePlaylockReq P_((struct playlock_cpacket *packet));
extern void handleDetMReq P_((struct det_mytorp_cpacket *packet));
extern void handleTractorReq P_((struct tractor_cpacket *packet));
extern void handleRepressReq P_((struct repress_cpacket *packet));
extern void sendMotdLine P_((char *line));
extern void handleCoupReq P_((struct coup_cpacket *packet));
extern void handleRefitReq P_((struct refit_cpacket *packet));
extern void handleSMessageReq P_((struct mesg_s_cpacket *packet));
extern void handleMessageReq P_((struct mesg_cpacket *packet));
extern void clientVersion P_((struct mesg_cpacket *packet));
extern void handleQuitReq P_((struct quit_cpacket *packet));
extern void sendMaskPacket P_((int mask));
extern void handleOptionsPacket P_((struct options_cpacket *packet));
extern void handleSocketReq P_((struct socket_cpacket *packet));
extern void handleByeReq P_((struct bye_cpacket *packet));
extern int checkVersion P_((void));
extern void logEntry P_((void));
extern int parseSpecial P_((struct mesg_cpacket *packet));
extern int gwrite P_((int fd, char *wbuf, register int bytes));
extern void handleDockingReq P_((struct dockperm_cpacket *packet));
extern void handleReset P_((struct resetstats_cpacket *packet));
extern void handleUpdatesReq P_((struct updates_cpacket *packet));
extern void logmessage P_((char *string));
extern void handleReserved P_((struct reserved_cpacket *packet));
extern void handleRSAKey P_((struct rsa_key_cpacket *packet));
extern void handlePingResponse P_((struct ping_cpacket *packet));
extern void handleOggV P_((struct oggv_cpacket *packet));
extern void handleFeature P_((struct feature_cpacket *cpacket));
extern void sendFeature P_((struct feature_spacket *packet));
extern void handleUdpReq P_((struct udp_req_cpacket *packet));
extern int connUdpConn P_((void));
extern int closeUdpConn P_((void));
extern void printUdpInfo P_((void));
extern void handleSequence P_((void));
extern int addSequence P_((char *outbuf));
extern void forceUpdate P_((void));
extern int check_mesgs P_((struct mesg_cpacket *packet));
extern char *addrs P_((struct mesg_cpacket *packet));
extern int parseQuery P_((struct mesg_spacket *packet));
extern int bounceSessionStats P_((struct mesg_spacket *packet));
extern int bounceSBStats P_((struct mesg_spacket *packet));
extern int bounceBaseStats P_((struct mesg_spacket *packet));
extern int bouncePingStats P_((struct mesg_spacket *packet));
extern int bounceRSAClientType P_((struct mesg_spacket *packet));
extern int bounceBD P_((struct mesg_spacket *packet));
extern void bounce P_((char *bouncemsg, int bounceto));
extern void handleShortReq P_((struct shortreq_cpacket *packet));
extern void handleThresh P_((struct threshold_cpacket *packet));
extern void updateVPlayer P_((struct player_spacket *p));
extern void sendVPlayers P_((void));
extern void SupdateTorps P_((void));
extern int gethostnames P_((char (**sbuf)[16]));
extern void forceShutdown P_((int s));
extern void sendMotdPic P_((int index, int x, int y, char *bits, int line, int color, int width, int height));
extern void sendBitmap P_((int bitmap_type, int width, int height, int size, char *bits));
/* smessage.c */
extern void pmessage P_((char *str, int recip, int group, char *address));
extern void pmessage2 P_((char *str, int recip, int group, char *address, int from));
extern void processSelfTalk P_((char *str, int from));
extern void doOther P_((char *str, int from));
extern void vote_yes P_((unsigned int *i, char *s));
extern void vote_no P_((unsigned int *i, char *s));
extern void doSpecial P_((char *str, int from));
extern char *getaddr2 P_((int flags, int from, int recip));
/* startdaemon.c */
extern void startdaemon P_((void));
extern void practice_robo P_((struct player *p));
/* torp.c */
extern void ntorp P_((int course, int type));
extern int vector_torp_speed P_((int pdir, int pspeed, int tdir, int tspeed));
/* transwarp.c */
extern int handleTranswarp P_((void));
/* warning.c */
extern void warning P_((int force, char *text, int sid));
extern void s_warning P_((char *text, int index));
extern void swarning P_((int whichmessage, int argument, int argument2));
extern void swarning2 P_((int w_1, int arg1_1, int arg2_1, int w_2, int arg1_2, int arg2_2));
/* rsa_key.c */
extern void makeRSAPacket P_((struct rsa_key_spacket *packet));
extern int decryptRSAPacket P_((struct rsa_key_spacket *spacket, struct rsa_key_cpacket *cpacket, char *serverName, struct rsa_key *key));
/* rsa_util.c */
extern void rsa_encode P_((char *out, char *message, char *key, char *global, int digits));
/* sintab.c */
/* mypopen.c */
extern FILE *mypopen P_((char *cmd, char *cmds, char *mode));
extern int mypclose P_((FILE *ptr));
/* data.c */
/* sysdefaults.c */
extern int readsysdefaults P_((void));
extern int YesNo P_((char *p));
extern void readstrings P_((char *type, char *string, char **keys, int *array, int max));
extern int update_sys_defaults P_((int daemon));
extern int dotimecheck P_((void));
extern int parseday P_((char *day_s));
extern int todayday P_((void));
extern time_t convtime P_((int v));
extern int time_is_now P_((time_t tl, time_t th));
/* util.c */
extern int angdist P_((int x, int y));
extern void copy80 P_((char *dest, char *addr_format, char *address, char *str));
extern void my_sleep P_((int secs));
extern char *strdup P_((const char *str));
extern int mstime P_((void));
/* realnumships.c */
extern int realNumShips P_((int owner));
/* feature.c */
extern void readFeatures P_((void));
extern void getFeature P_((struct feature_cpacket *cpack, struct feature_spacket *spack));
extern int feature_cmp P_((char *f, char *s));
extern void F_tellClient P_((char *typ));
/* distress.c */
extern int itoa2 P_((int n, char s[]));
extern void dist_error P_((char *str, char *macro, int ch));
extern void HandleGenDistr P_((char *message, int from, int to, struct distress *dist));
extern void Dist2Mesg P_((struct distress *dist, char *buf));
extern int makedistress P_((struct distress *dist, char *cry, char *pm));
extern void testmacro P_((char *bufa, char *bufb, int *inda, int *indb));
extern int solvetest P_((char *bufa, int *inda));
extern void condmacro P_((char *bufa, char *bufb, int *inda, int *indb, int flag));
extern int skipmacro P_((char buf[], int index));
/* bd.c */
extern void bd_phaser P_((unsigned char dir));
extern void bd_dir P_((char *desc, unsigned char dir));
extern void bd_update P_((int delay, int angdiff));
extern int bd_borg P_((int *counts, int *hits, int *gt, int *rgt));
extern void bd_torp P_((int dir));

#undef P_
