/*
 * dmessage.c 
 *
 * for the client of a socket based protocol.
 */
#include "copyright.h"

#include <stdio.h>
#include <math.h>
#include "Wlib.h"
#include "defs.h"
#include "xsg_defs.h"
#include "struct.h"
#include "data.h"


dmessage(message,flags,from,to)
char *message;
unsigned char flags, from, to;
{
    register int len;
    W_Color color;
    struct distress dist;
    char buf[256];

#ifdef RCD
    if(flags == (MDISTR | MTEAM | MVALID)){
       HandleGenDistr(message, from, to, &dist);
       makedistress(&dist, buf, distmacro[dist.distype].macro);
    }
    else{
       strncpy(buf, message, MSG_LEN);
       buf[MSG_LEN-1] = 0;
    }
#else
    strncpy(buf, message, MSG_LEN);
    buf[MSG_LEN-1] = 0;
#endif
    len = strlen(buf);

    if (from==255) {
	/* From God */
	color=textColor;
    } else if(from < MAXPLAYER){
	color=playerColor(&(players[from]));
    }
    else{
      fprintf(stderr, "Bad 'from' field (%d) for message \"%s\"\n",
	 from, buf);
      return;
    }

    /* Kludge stuff for report kills... 
     */
    if ((strncmp(buf, "GOD->ALL", 8)==0 && 
	  (instr(buf, "was kill") ||
	  instr(buf, "killed by"))) || 
	  (*buf!=' ' && instr(buf, "We are being attacked"))) {
	if (!reportKills) return;
	W_WriteText(reviewWin, 0, 0, color, buf, len, 0);
	return;
    }
    if (!strncmp(buf+5, "GOD", 3) && msgBeep)	/* msg to GOD? */
	W_Beep();
    W_WriteText(reviewWin, 0, 0, color, buf, len, 0);

    update_sys_defaults();		/* after "rules of game" message */

    flags = to;		/* make compiler shut up */
}

instr(string1, string2)
char *string1, *string2;
{
    char *s;
    int length;

    length=strlen(string2);
    for (s=string1; *s!=0; s++) {
	if (*s == *string2 && strncmp(s, string2, length)==0) return(1);
    }
    return(0);
}

checkMsgs()
{
    if (oldmctl != mctl->mc_current) {
	oldmctl++;
	if (oldmctl>=MAXMESSAGE) oldmctl=0;
	dmessage(messages[oldmctl].m_data, messages[oldmctl].m_flags, 
	   (unsigned char) messages[oldmctl].m_from, 0);
    }
}

